//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#include <stdlib.mqh>

//
//
//
//
//

#include <TimeGMT nmc.mqh>  

//
//
//
//
//

extern bool   EcnBroker        = true;
extern string SymbolsPrefix    = "";
extern string SymbolsSuffix    = "";
extern bool   UseAutoMagic     = true;
extern int    ManualMagic      = 7654321;
extern bool   SignalMail       = false;  
extern bool   EachTickMode     = false;
extern double Lots             = 0.01;
extern int    Slippage         = 3;
extern bool   StopLossMode     = true;
extern int    StopLoss         = 50;
extern bool   TakeProfitMode   = true;
extern int    TakeProfit       = 200;
extern bool   TrailingStopMode = true;
extern int    TrailingStop     = 30;
extern bool   BreakEvenMode    = false;
extern int    BreakEven        = 40;
extern int    BreakEvenGap     = 10;
extern double MaximumRisk      = 0.001;
extern double DecreaseFactor   = 3;
extern int    MaxOrders        = 3;
extern bool   stoponstepma     = true;

extern string _note            = "StepMa Parameters";
extern int    Length           = 21;      // Volty Length
extern double Kv               = 1.0;     // Sensivity Factor
extern int    StepSize         = 0;       // Constant Step Size (if need)
extern int    MA_Mode          = 0;       // Volty MA Mode : 0-SMA, 1-LWMA 
extern int    Advance          = 0;       // Offset
extern double Percentage       = 0;       // Percentage of Up/Down Moving   
extern double UpDownShift      = 0;       // Number of Up/Down Moving, in points. 
extern bool   HighLow          = false;   // High/Low Mode Switch (more sensitive)

extern string cl_note          = "StepMa Close Parameters";
extern int    clLength         = 21;      // Volty Length
extern double clKv             = 1.0;     // Sensivity Factor
extern int    clStepSize       = 0;       // Constant Step Size (if need)
extern int    clMA_Mode        = 0;       // Volty MA Mode : 0-SMA, 1-LWMA 
extern int    clAdvance        = 0;       // Offset
extern double clPercentage     = 0;       // Percentage of Up/Down Moving   
extern double clUpDownShift    = 0;       // Number of Up/Down Moving, in points. 
extern bool   clHighLow        = false;   // High/Low Mode Switch (more sensitive)
extern int    closeBuybar      = 3;
extern int    closeSellbar     = 3;

extern string comments         = "Comments on true or false"; 
extern bool   CommentsOn       = true;   

extern string _time            = "Time Filter";
extern int    StartHour        = 0;          // Start Hour of Trade Session 
extern int    StartMinute      = 0;          // Start Minute of Trade Session 
extern int    EndHour          = 23;         // End Hour of Trade Session
extern int    EndMinute        = 0;          // End Hour of Trade Session

//
//
//
//
//

#define SIGNAL_NONE 0
#define SIGNAL_BUY  1
#define SIGNAL_SELL 2
#define SIGNAL_CLOSEBUY  3
#define SIGNAL_CLOSESELL 4

//
//
//
//
//

int    ColorMode   = 2; 
int    clColorMode = 2; 
int    BarCount;
int    Current;
int    digit = 0;
int    ortype;
int    MagicNumber;

bool   TickCheck = false;

string s_symbol;
string timeFilterText="";

double PointRatio = 1;
double pipModifier;
bool dummyResult;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init() 
{
   BarCount = Bars;
   
   if (EachTickMode) Current = 0; 
                else Current = 1;
                
   s_symbol = Symbol();
   if (UseAutoMagic) MagicNumber = GetMagic();
               else  MagicNumber = ManualMagic; 
              
              
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit() 
{ 

    Comment(" ");

return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start() 
{
   if (!IsDllsAllowed()) 
   {
     Alert("DLLs are disabled.  To enable check the box in the tools/options/expert advisors on your chart");
     return(0);
   }
   
   //
   //
   //
   //
   //
   
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==3 || digit==5) 
         PointRatio = 10;
   else  PointRatio = 1; 
   pipModifier  = MarketInfo(s_symbol,MODE_POINT) * PointRatio;  
   
   //
   //
   //
   //
   //
   
   if (EachTickMode && Bars != BarCount) EachTickMode = False;
   int Total = OrdersTotal();
   
   //
   //
   //
   //
   //
   
   if (CommentsOn) ShowComments();
   
   //+------------------------------------------------------------------+
   //| Signal Begin                                                     |
   //+------------------------------------------------------------------+
   //
   //
      int Order = SIGNAL_NONE;
      double Buy1_1  = iCustom(s_symbol,0,"StepMA_v7",Length,Kv,StepSize,MA_Mode,Advance,Percentage,UpDownShift,HighLow,ColorMode,0,4,Current);
      double Buy1_2  = iCustom(s_symbol,0,"StepMA_v7",Length,Kv,StepSize,MA_Mode,Advance,Percentage,UpDownShift,HighLow,ColorMode,0,4,Current+1);
          
      double Sell1_1 = iCustom(s_symbol,0,"StepMA_v7",Length,Kv,StepSize,MA_Mode,Advance,Percentage,UpDownShift,HighLow,ColorMode,0,3,Current);
      double Sell1_2 = iCustom(s_symbol,0,"StepMA_v7",Length,Kv,StepSize,MA_Mode,Advance,Percentage,UpDownShift,HighLow,ColorMode,0,3,Current+1);
      
      int    orderOpenBar = iBarShift(NULL,0,OrderOpenTime(),true);

      double CloseBuy1_1  = iCustom(s_symbol,0,"StepMA_v7",clLength,clKv,clStepSize,clMA_Mode,clAdvance,clPercentage,clUpDownShift,clHighLow,clColorMode,0,4,Current);
      double CloseBuy1_2  = iCustom(s_symbol,0,"StepMA_v7",clLength,clKv,clStepSize,clMA_Mode,clAdvance,clPercentage,clUpDownShift,clHighLow,clColorMode,0,4,Current+1);
           
      double CloseSell1_1 = iCustom(s_symbol,0,"StepMA_v7",clLength,clKv,clStepSize,clMA_Mode,clAdvance,clPercentage,clUpDownShift,clHighLow,clColorMode,0,3,Current);
      double CloseSell1_2 = iCustom(s_symbol,0,"StepMA_v7",clLength,clKv,clStepSize,clMA_Mode,clAdvance,clPercentage,clUpDownShift,clHighLow,clColorMode,0,3,Current+1);

      //
      //
      //
      //
      //
      
      if (Close[Current] > Buy1_1  && Close[Current+1] <= Buy1_2  && TimeCondition()) Order = SIGNAL_BUY;
      if (Close[Current] < Sell1_1 && Close[Current+1] >= Sell1_2 && TimeCondition()) Order = SIGNAL_SELL;
      
   //+------------------------------------------------------------------+
   //|                                                                  |
   //+------------------------------------------------------------------+
   //
   //Buy
   
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
   {
     if (ScanTrades() < MaxOrders) 
     {
     
     //
     //
     //
     //
     //
     
       if (AccountFreeMargin() < (100 * Lots)) {Print("We have no money. Free Margin = ", AccountFreeMargin());return(0);}
       
       //
       //
       //
       //
       //
       
       double BStopLossLevel   = Ask - StopLoss   * pipModifier;
       double BTakeProfitLevel = Ask + TakeProfit * pipModifier;
       
       //
       //
       //
       //
       //
       
       if (!EcnBroker) 
       dummyResult = OrderSend(s_symbol,OP_BUY,LotsOptimized(),NormalizeDouble(Ask,digit),Slippage*pipModifier,NormalizeDouble(BStopLossLevel,digit),  
                                    NormalizeDouble(BTakeProfitLevel,digit),"Buy(#" + MagicNumber + ")",MagicNumber,0,DodgerBlue);
       else
       {
       int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),NormalizeDouble(Ask,digit),Slippage*pipModifier,0,0,"Buy(#" + MagicNumber + ")", MagicNumber,0,Blue);
       if  (buyTicket  >= 0)
       bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),NormalizeDouble(BStopLossLevel,digit),NormalizeDouble(BTakeProfitLevel,digit),0,CLR_NONE);
    
       if (OrderSelect(buyTicket, SELECT_BY_TICKET, MODE_TRADES)) Print("BUY order opened : ", OrderOpenPrice()); else Print("Error opening BUY order : ", GetLastError());
       }
       
       if (EachTickMode)  TickCheck = True;
       if (!EachTickMode) BarCount  = Bars;
       
       return(0);
      }
   }

   //Sell
   //
   //
   //
   //
   
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
   {
      if (ScanTrades() < MaxOrders) 
      {
      
      //
      //
      //
      //
      //
         
         if (AccountFreeMargin() < (1000 * Lots)) {Print("We have no money. Free Margin = ", AccountFreeMargin());return(0);}
         
         //
         //
         //
         //
         //
         
         double SStopLossLevel   = Bid + StopLoss   * pipModifier;
         double STakeProfitLevel = Bid - TakeProfit * pipModifier;
         
         //
         //
         //
         //
         //
         
         if (!EcnBroker)
         dummyResult = OrderSend(s_symbol,OP_SELL,LotsOptimized(),NormalizeDouble(Bid,digit),Slippage*pipModifier,NormalizeDouble(SStopLossLevel,digit),  
                                        NormalizeDouble(STakeProfitLevel,digit),"Sell(#" + MagicNumber + ")",MagicNumber,0,DeepPink);
         
         
         else
         {
		   int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),NormalizeDouble(Bid,digit),Slippage*pipModifier,0,0,"Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(sellTicket    >= 0) 
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),NormalizeDouble(SStopLossLevel,digit),NormalizeDouble(STakeProfitLevel,digit),0,CLR_NONE);
         if (OrderSelect(sellTicket, SELECT_BY_TICKET, MODE_TRADES)) Print("SELL order opened : ", OrderOpenPrice()); 
         else Print("Error opening SELL order : ", GetLastError());
         }
         
         if (EachTickMode)  TickCheck = True;
         if (!EachTickMode) BarCount  = Bars;
         return(0);
      }
   }

   //
   //
   //
   //
   //
   
   bool IsTrade = false;
   for (int i = 0; i < Total; i ++) 
   {
      dummyResult = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderType() <= OP_SELL &&  OrderSymbol() == s_symbol) 
      {
        if (OrderType() == OP_BUY && OrderMagicNumber()== MagicNumber) 
        {
         
            //
            //
            //
            //
            //
            
            if (orderOpenBar >= closeBuybar)       
            {     
               if (stoponstepma == true) { if (Close[Current] < CloseBuy1_1  && Close[Current+1] <= CloseBuy1_2) { Order = SIGNAL_CLOSEBUY; }}                        
            }
            
            //
            //
            //
            //
            //
            
            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
            {
               dummyResult = OrderClose(OrderTicket(), OrderLots(), Bid, Slippage*pipModifier, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + s_symbol + "] " + DoubleToStr(Bid,digit) + " Close Buy");
               if (EachTickMode)  TickCheck = true;
               if (!EachTickMode) BarCount  = Bars;
               IsTrade = false;
               return(0);
            }
            
            //
            //
            //
            //
            //
            
            if(TrailingStopMode && TrailingStop > 0)
            {                 
              if(Bid - OrderOpenPrice()  > pipModifier * TrailingStop) {
                if(OrderStopLoss() < Bid - pipModifier * TrailingStop) {
                   dummyResult = OrderModify(OrderTicket(), OrderOpenPrice(), Bid - pipModifier * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                   if (!EachTickMode) BarCount = Bars;
                   return(0);
                  }
               }
            }
            
            //
            //
            //
            //
            //
            
            if (BreakEvenMode && BreakEven > 0)
            {
			        double BuyStop = OrderStopLoss();
			        if (NormalizeDouble(Bid-OrderOpenPrice(),digit) > NormalizeDouble(BreakEven*pipModifier,digit)) 
			        {
			           BuyStop=OrderOpenPrice()+(BreakEven+BreakEvenGap)*pipModifier;
			           dummyResult = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(BuyStop,digit),OrderTakeProfit(),0,LightBlue);
			           if (!EachTickMode) BarCount = Bars;
			           return(0);
			         }
			   }
            
            //
            //
            //
            //
            //
            
            } 
            else 
            {
         
            if(OrderType()==OP_SELL && OrderMagicNumber()==MagicNumber)
            {
           
            //
            //
            //
            //
            //
            
            if (orderOpenBar >= closeSellbar)
            {
               if (stoponstepma == true) { if (Close[Current] > CloseSell1_1 && Close[Current+1] <= CloseSell1_2) { Order = SIGNAL_CLOSESELL; }}                          
            }
            
            //
            //
            //
            //
            //

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
            {
               dummyResult = OrderClose(OrderTicket(), OrderLots(), Ask, Slippage*pipModifier, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + s_symbol + "] " + DoubleToStr(Ask,digit) + " Close Sell");
               if (EachTickMode)  TickCheck = True;
               if (!EachTickMode) BarCount  = Bars;
               IsTrade = false;
               return(0);
            }
               
            //
            //
            //
            //
            //
            
            if (TrailingStopMode && TrailingStop > 0) 
            {                 
               if((OrderOpenPrice() - Ask)   > (pipModifier * TrailingStop)) {
                  if((OrderStopLoss() > (Ask +  pipModifier * TrailingStop)) || (OrderStopLoss() == 0)) {
                     dummyResult = OrderModify(OrderTicket(), OrderOpenPrice(), Ask + pipModifier * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     return(0);
                  }
               }
            }
            
            //
            //
            //
            //
            //
            
            if (BreakEvenMode && BreakEven > 0)
            {
               double SellStop = OrderStopLoss();
               if (NormalizeDouble(OrderOpenPrice()-Ask,digit) > NormalizeDouble(BreakEven*pipModifier,digit)) 
			      {
			         SellStop=OrderOpenPrice()-(BreakEven+BreakEvenGap)*pipModifier;
			         dummyResult = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SellStop,digit),OrderTakeProfit(),0,Orange);
			         if (!EachTickMode) BarCount = Bars;
			         return(0);
			      }
			   }      
         }
       }
     }
   }

   if (!EachTickMode) BarCount = Bars;
return(0);
}

//
//
//
//
//

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   dummyResult = OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == s_symbol && OrderType() <= OP_SELLSTOP && OrderMagicNumber() == MagicNumber) 
   numords++;
   }
return(numords);
}  

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage() <= 0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
      
   if(losses > 1) lot = NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0) * lot_step;
   if(lot < lot_min) lot = lot_min;
   if(lot > lot_max) lot = lot_max;
   
return(lot);
} 

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(1933921);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(1933922);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(1933931);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(1933932);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(1933941);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(1933942);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(1933951);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(1933961);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(1933962);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(1933963);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(1933964);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(1933965);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(1933966);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(1933967);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(1933971);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(1933972);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(1933973);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(1933981);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(1933982);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(1933983);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(1933991);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(1933992);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(1933993);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(1933994);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(1933995);
   
return(ManualMagic);
}

//
//
//
//
//

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   {
   result = lTimeGMT() >= SessionStart && lTimeGMT() < SessionEnd; 
   { timeFilterText = "Trading Hours!"; }
   
   }    
   else
   {
   
   if (StartHour > EndHour)
   {
   result = (lTimeGMT() >= SessionStart && TimeHour(lTimeGMT()) < 24) || (TimeHour(lTimeGMT()) >= 0 && lTimeGMT() < SessionEnd);
   { timeFilterText = "Non-Trading Hours!"; }
   
   }
 }
return(result);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void ShowComments()
{ 
   if (IsTesting() && !IsVisualMode()) return;
   if (IsTesting()) return;
   
   string symbol   = Symbol(); if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);
  	double modifier = 1;
  	int    digits   = MarketInfo(symbol,MODE_DIGITS);
   if (digits==3 || digits==5) modifier = 10.0;
   
   //
   //
   //
   //
   //
   
   string strLocal  = TimeToStr(TimeLocal(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	string strServer = TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	string strGMT    = TimeToStr(lTimeGMT(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	
	
	string strLocalTimeZone;
	if (TimeZoneLocal() > 0)   strLocalTimeZone  = StringConcatenate("Local timezone: GMT plus  ", TimeZoneLocal()," hours");
	if (TimeZoneLocal() == 0)  strLocalTimeZone  = "Local timezone: GMT";
	if (TimeZoneLocal() < 0)   strLocalTimeZone  = StringConcatenate("Local timezone: GMT minus ",-TimeZoneLocal()," hours");
	
	string strServerTimeZone;
	if (TimeZoneServer() > 0)  strServerTimeZone = StringConcatenate("Server timezone: GMT plus  ", TimeZoneServer()," hours");
	if (TimeZoneServer() == 0) strServerTimeZone = "Server timezone: GMT";
  	if (TimeZoneServer() < 0)  strServerTimeZone = StringConcatenate("Server timezone: GMT minus ",-TimeZoneServer()," hours");
   
  	//
  	//
  	//
  	//
  	//
  
   if(MarketInfo(Symbol(),MODE_SWAPLONG) > 0)                                  string    swap="longs,";
                                                                               else      swap="shorts.";
   if(MarketInfo(Symbol(),MODE_SWAPLONG) < 0 && MarketInfo(Symbol(),MODE_SWAPSHORT) < 0) swap="your broker. ";
   
   //
   //
   //
   //
   //  
   
   string sComment   = "";
   string sp         = "---------------------------------------------------\n";
   string NL         = "\n";
   
   
   sComment = sComment + sp;
   sComment = sComment + "StepMa Ea_v7" + NL; 
   sComment = sComment + sp;
   sComment = sComment + timeFilterText + NL; 
   sComment = sComment + sp;
   sComment = sComment + "Market Analysis" + NL;
   sComment = sComment + "Swap favors " + swap + NL; 
   sComment = sComment + "Swap Long      = " + DoubleToStr(MarketInfo(symbol,MODE_SWAPLONG),2) + NL; 
   sComment = sComment + "Swap Short     = " + DoubleToStr(MarketInfo(symbol,MODE_SWAPSHORT),2) + NL; 
   sComment = sComment + "Current Spread = " + DoubleToStr(MarketInfo(symbol,MODE_SPREAD)/ modifier,2) + NL;  
   sComment = sComment + sp;
   sComment = sComment + "Time Information" + NL;
   sComment = sComment + strLocalTimeZone  + NL;
   sComment = sComment + strServerTimeZone + NL;
   sComment = sComment + "Local time from PC clock = " +strLocal+ NL;
   sComment = sComment + "Broker server time         =  " +strServer+ NL;
   sComment = sComment + "GMT time                    =  " +strGMT+ NL;
   sComment = sComment + sp;
   sComment = sComment + "Have a great trading day" + NL;
   sComment = sComment + sp; 
   
   Comment(sComment);  
}